#include "huc.h"

#incbin(map,"map.fmp")

#incchr(tile1_gfx, "tile1.pcx");
#incpal(tile1_pal, "tile1.pcx", 0, 1);

#incchr(tile2_gfx, "tile2.pcx");
#incpal(tile2_pal, "tile2.pcx", 0, 1);

#define  BAT_L 32
#define  BAT_H 32

#define  MAP_L 32
#define  MAP_H 32

const char pal_ref[92]={   /* 64 + 28 */
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,

2,2,2,2,2,2,2,2,
2,2,2,2,2,2,2,2,
2,2,2,2,2,2,2,2,
2,2,2,2};

/* ##################### FADE OUT ####################### */
fade_out(color1,nb)
char color1,nb;
{
char r,g,b,i,fin;

fin=1;

while (fin)
   {
   fin=0;

   for (i=color1;i<color1+nb;i++)
      {
            
      b= get_color(i) & 7;
      r= (get_color(i)>>3) & 7;
      g= (get_color(i)>>6) & 7;
   
      if (r) r--;
      if (g) g--;
      if (b) b--;
      
      set_color_rgb(i, r, g, b);
      if (r+g+b) fin=1;
      }

   vsync(3);
   }
disp_off();
}



/* ##################### FADE IN ######################## */

fade_in(color1,nb)
char color1,nb;
{
char r,g,b,r2,g2,b2,i,fin;
int pal_tab[256];

for (i=color1;i<color1+nb;i++)
   {
   pal_tab[i] = get_color(i);
   set_color(i,0);
   }

fin=1;
disp_on();

while (fin)
   {
   fin=0;
   
   for (i=color1;i<color1+nb;i++)
         {
              
         b= get_color(i) & 7;
         r= (get_color(i)>>3) & 7;
         g= (get_color(i)>>6) & 7;
      
         b2= pal_tab[i] & 7;
         r2= (pal_tab[i]>>3) & 7;
         g2= (pal_tab[i]>>6) & 7;
   
         if (b!=b2) {b++; fin=1; }
         if (r!=r2) {r++; fin=1; }
         if (g!=g2) {g++; fin=1; }
         
         set_color_rgb(i, r, g, b);
         }
   vsync(3);
   }
}


/* ####################### Procedure to make the BAT ################## */
make_bat(bat_x,bat_y,map_x,map_y,l,h)
char bat_x,bat_y,map_x,map_y,l,h;
{
char i,j;
int bat_offset,map_offset;

for (j=0;j<h;++j)
{
   for (i=0;i<l;++i)
      {
      bat_offset=((bat_y+j)*BAT_L)+(bat_x+i);
      map_offset=((map_y+j)*MAP_L)+(map_x+i);
      vram[bat_offset]= (0x100 + map[map_offset]) | (pal_ref[map[map_offset]]<<12);
      }
}

}






main ()
{

set_screen_size(0x00);    /* Screen size 32x32 */



load_vram(0x1000, tile1_gfx, 0x400); 
/* I load the first part of the tiles at 0x1000 
0x400 = 0x10 (1tile) x 64 */

load_vram(0x1400, tile2_gfx, 0x1C0);
/* I load the second part of the tiles at 0x1400 
0x1C0 = 0x10 (1tile) x 28 */

/* I load the 2 palettes */



disp_off();


/*
I use my special procedure:

make_bat(bat_x,bat_y,map_x,map_y,l,h)

bat_x : x of the screen to load the map
bat_y : y of the screen to load the map

map_x : x of origine of the map
map_y : y of origine of the map

l : width to load
h : height to load
*/

make_bat(0,0,0,0,32,32);





for (;;)
{

set_bgpal(1, tile1_pal);
set_bgpal(2, tile2_pal);

if (RUN) fade_in(16,32);
         /* 
         fade_in(color1,nb)
         
         color1 : first color index
         nb : number of color to fade
         
         ex: to fade only the bg pal 0, just do fade_in(0,16)
         */ 


if (SELECT) fade_out(16,32);

          /* 
          fade_out(color1,nb)
          
          color1 : first color index
          nb : number of color to fade
          
          ex: to fade only the bg pal 0, just do fade_out(0,16)
          */ 
   
vsync();
}


}




